/*
Copyright (c) 2001 Dan Vernon

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version. This program is
distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. You should have received a copy of the GNU
General Public License along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// Timer.cpp: implementation of the CuTimer class.
//
//////////////////////////////////////////////////////////////////////


#ifdef WIN32
#include "stdafx.h"
#else if __GNUC__
#include "gnuDefines.h"
#endif


#include "utimer.h"

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CuTimer::CuTimer()
{
	calibrateTimer();
}

CuTimer::~CuTimer()
{
}

void CuTimer::calibrateTimer()
{
	QueryPerformanceFrequency(&liFreq);
}

void CuTimer::usleep(DWORD us)
{
	LARGE_INTEGER liNow;
	LARGE_INTEGER liCycles;
	QueryPerformanceCounter(&liNow);
	liCycles.QuadPart=liNow.QuadPart+liFreq.QuadPart*us/1000000;
	while (liNow.QuadPart<liCycles.QuadPart)
		QueryPerformanceCounter(&liNow);
}

void CuTimer::begin()
{
	QueryPerformanceCounter(&liTimer);
}

//to print this thing use the format "%I64d"
LONGLONG CuTimer::utime()
{
	LARGE_INTEGER liNow;
	QueryPerformanceCounter(&liNow);
	liNow.QuadPart = ((liNow.QuadPart-liTimer.QuadPart)*1000000)/liFreq.QuadPart;
	return liNow.QuadPart;
}