/*
Copyright (c) 2001 Dan Vernon

This program is free software; you can redistribute it and/or modify it under the terms 
of the GNU General Public License as published by the Free Software Foundation; either 
version 2 of the License, or (at your option) any later version. This program is 
distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. You should have received a copy of the GNU
General Public License along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

/*
 * for documentation of the SIO command bytes and protocols,
 * see the Atari Personal Computer System Operating System User's Manual
 * Atari Part No. CO16555.
 * relevant sections referenced in this code are:
 * chapter 5 -- I/O subsystems
 *					Serial bus I/O (SIO)
 * chapter 9 -- Adding new device handlers/peripherals
 *					Handler/SIO interface
 *					Serial I/O bus characteristics and protocol
 */

#define SIO_WAIT_COMPLETE		 0 //  1500   // min=250us, max=255sec. (ch. 9 of CO16555)
#define SIO_WAIT_DATA_ACK	     0 //   850   // min=850us, max=16ms       "       "
#define SIO_WAIT_CMD_ACK         0 //    10   // min=0us  , max=16ms       "       "

#define SIO_COMMAND_SIZE		  	  5
#define SIO_STATUS_SIZE				  4
#define SIO_MAX_DISKS                 9
#define SIO_SD_SECTOR_SIZE			128
#define SIO_DD_SECTOR_SIZE			256
#define SIO_SSSD_SECTOR_NUM			720
#define SIO_SSED_SECTOR_NUM        1040
#define SIO_MAX_SECTOR_SIZE        1024

