/*
Copyright (c) 2001 Dan Vernon

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version. This program is
distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. You should have received a copy of the GNU
General Public License along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// sioPort.h: interface for the CSIOPort class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SIOPORT_H__B614CC66_E23C_49C9_8983_DA15C71AEE36__INCLUDED_)
#define AFX_SIOPORT_H__B614CC66_E23C_49C9_8983_DA15C71AEE36__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#define SERIAL_API_RING           1
#define SERIAL_API_READ           2
#define SERIAL_API_WRITE          3

#define MAX_STATUS_BUFFER       4096
#define MAX_WRITE_BUFFER        2048
#define MAX_READ_BUFFER         2048
#define ASCII_XON               0x11
#define ASCII_XOFF              0x13

//#define EVENTFLAGS_DEFAULT      EV_RING|EV_ERR|EV_RXCHAR|EV_RXFLAG|EV_BREAK|EV_TXEMPTY|EV_RX80FULL|EV_CTS|EV_DSR|EV_RLSD
#define EVENTFLAGS_DEFAULT      EV_RING

#include "innerShell.h"


class CSIOPort
{
public:
	CSIOPort();
	virtual ~CSIOPort();

	bool setSerialPort(BYTE portNumber);
	bool openPort(BYTE portNumber);
	bool readBytes(BYTE* chunk,DWORD ct);
	bool writeBytes(BYTE* chunk,DWORD ct);
	bool writeAck(BYTE byte);
	bool waitForRing();
	void closePort();
	void resetPort();
	bool ringInterruptFlag;
	bool setSpeed(DWORD baudRate);
	DWORD currentBaud;
	BYTE portNumber;
	BYTE maxSpeed;
	bool portOpened;

private:
	void reportPortStatus(DWORD status);
	bool doOverlappedComCrud(DWORD func, DWORD count, BYTE* chunk);
	bool clearError();
	DCB dcb;

#ifdef WIN32
	HANDLE handleCom;
	OVERLAPPED overlapRing;
	OVERLAPPED overlapReadWrite;
#endif

};

#endif // !defined(AFX_SIOPORT_H__B614CC66_E23C_49C9_8983_DA15C71AEE36__INCLUDED_)
