/*
Copyright (c) 2001 Dan Vernon

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version. This program is
distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. You should have received a copy of the GNU
General Public License along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// sioProtocol.h: interface for the CSIOProtocol class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_SIOPROTOCOL_H__DDB828B5_EE3D_432C_9789_239DF82DA55E__INCLUDED_)
#define AFX_SIOPROTOCOL_H__DDB828B5_EE3D_432C_9789_239DF82DA55E__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "diskImage.h"
#include "sioPort.h"
#include "utimer.h"
#include "sioConstants.h"

class CSIOPort;
class CDiskImage;

class CSIOProtocol
{
public:
	void swapDisks(BYTE sioid1,BYTE sioid2);
	CSIOProtocol();
	virtual ~CSIOProtocol();

	CSIOPort* sioPort;
	BYTE badSectorMapSD[SIO_SD_SECTOR_SIZE+1];       //one byte extra for checksum
	BYTE badSectorMapDD[SIO_DD_SECTOR_SIZE+1];       //one byte extra for checksum

	void listen();
	bool mount(LPSTR path, BYTE sioid, bool readOnly);
	bool release(BYTE sioid);

	bool isValidCommand(BYTE* cmd);
	bool isKnownCommand(BYTE b);
	bool readSector(CDiskImage* di, WORD sector);
	bool writeSector(CDiskImage* di, WORD sector);
	bool printData(void);
	bool readConfiguration(CDiskImage* di);
	bool setConfiguration(CDiskImage* di);
	void handleCommand(BYTE* cmd);
	BYTE checkSum(BYTE* chunk,DWORD size);
	HANDLE diskMutex;
	CDiskImage* disk[SIO_MAX_DISKS+1];
	CDiskImage* printer;

private:
	CuTimer* timer;
	LPCSTR xlateCommand(BYTE b,BYTE aux0,BYTE aux1);
};

#endif // !defined(AFX_SIOPROTOCOL_H__DDB828B5_EE3D_432C_9789_239DF82DA55E__INCLUDED_)
