/*
Copyright (c) 2001 Dan Vernon

This program is free software; you can redistribute it and/or modify it under the terms
of the GNU General Public License as published by the Free Software Foundation; either
version 2 of the License, or (at your option) any later version. This program is
distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details. You should have received a copy of the GNU
General Public License along with this program; if not, write to the Free Software
Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
*/

// stateStore.h: interface for the CStateStore class.
//
//////////////////////////////////////////////////////////////////////

#if !defined(AFX_STATESTORE_H__2CD07B19_4567_4765_8BDB_B41C1C1B68CA__INCLUDED_)
#define AFX_STATESTORE_H__2CD07B19_4567_4765_8BDB_B41C1C1B68CA__INCLUDED_

#if _MSC_VER > 1000
#pragma once
#endif // _MSC_VER > 1000

#include "innerShell.h"

class CStateStore  
{
public:
	CStateStore();
	virtual ~CStateStore();

	bool start(bool silent=false);
	bool stop(bool silent=false);
	bool isStopped();
	bool isStarted();
	
	void monitorQueue();
	void emptyQueue();

	bool isQueueMonitorStopped();
	bool isSioMonitorStopped();

	bool isErrorSet();
	bool isCancelSet();
	bool isQueueThreadDeathSet();
	bool isDebugSet();
	bool isTraceSet();
	bool isLogSet();
	bool isHappyRWModeSet();

	void setError(bool flag);
	void setCancel(bool flag);
	void setDebug(bool flag);
	void setTrace(bool flag);
	void setLog(bool flag);
	void setHappyRWMode(bool flag);
	void setQueueThreadDeath(bool flag);

	void setCurrentSpeed(BYTE newval);
	BYTE getCurrentSpeed();

	HANDLE cancelEvent;
	HANDLE errorEvent;
	HANDLE debugEvent;
	HANDLE traceEvent;
	HANDLE logEvent;
	HANDLE happyRWModeEvent;
	HANDLE queueThreadDeathEvent;

	void setEvent(HANDLE event, bool flag);
	bool isEventSet(HANDLE event);
	bool speedUpActive;

private:
	BYTE currentSpeed;
	HANDLE sioThread;
	HANDLE queueThread;
	HANDLE controlMutex;
	HANDLE currentSpeedMutex;
};

#endif // !defined(AFX_STATESTORE_H__2CD07B19_4567_4765_8BDB_B41C1C1B68CA__INCLUDED_)
