// SharePoint.cpp: implementation of the CSharePoint class.
//
//////////////////////////////////////////////////////////////////////

#include "stdafx.h"
#include "atariSioDriver.h"
#include "sharePoint.h"

#ifdef _DEBUG
#undef THIS_FILE
static char THIS_FILE[]=__FILE__;
#define new DEBUG_NEW
#endif

//////////////////////////////////////////////////////////////////////
// Construction/Destruction
//////////////////////////////////////////////////////////////////////

CSharePoint::CSharePoint()
{
	memset(&vtoc,0,sizeof(vtoc));
	memset(&vtoc.sectorMap[38],0xff,80);
	vtoc.w0=0xff3c;
	vtoc.w1=0xff;
	vtoc.w2=0xf;
	memset(&directorySector,0x20,sizeof(directorySector));
	this->sectorCount=SIO_SSED_SECTOR_NUM;
	this->sectorSize=SIO_SD_SECTOR_SIZE;
}

CSharePoint::~CSharePoint()
{
}

bool CSharePoint::load(LPSTR folderpath, bool isReadOnly)
{
	return true;
}

WORD CSharePoint::readSector(BYTE* sb, WORD sector)
{
	switch(sector)
	{
	case 0: //boot
	case 1:
	case 2:
	case 3:
	case 4:
		memset(sb,0,SIO_SD_SECTOR_SIZE);
		break;

	case 360: //vtoc
		memcpy(sb,&vtoc,sizeof(vtoc));
		break;

	case 361: //directory
	case 362:
	case 363:
	case 364:
	case 365:
	case 366:
	case 367:
	case 368:
		//getDirectorySector(sector);
		directorySector[0].flags=0x42;
		directorySector[0].sectorsInFile=0x0;
		directorySector[0].startingSector=0x10;
		wsprintf(directorySector[0].filename,"atari810");
		wsprintf(directorySector[0].extension,"%d",sector);

		memcpy(sb,&directorySector,sizeof(directorySector));
		break;

	default:
		/*
		if 10>sector && sector<74
		{
			getFirstFileSector(sb,sector); //open file, activeSector=1, fetch first 128 bytes
		}
		elseif (369+activeSector)
		{
			getNextFileSector(sb,sector);  //fetch next 128 byts, inc activeSector within bounds
										//activeSector++;
										//if (activeSector>(1024-370)) activeSector=0;
		}
		else
		{
			//NAK
		}
		*/
		if (false)
			;
		else
		{
			memset(sb,0,SIO_SD_SECTOR_SIZE);
		}
	}
	return SIO_SD_SECTOR_SIZE;
}

WORD CSharePoint::writeSector(BYTE* sb, WORD sector)
{
	return 0;
}

LPCSTR CSharePoint::description()
{
	wsprintf(desc," sharepoint");
	return desc;
}
