VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "CGUIOptions"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = False
'Copyright (c) 2001 Dan Vernon
'
'This program is free software; you can redistribute it and/or modify it under the terms
'of the GNU General Public License as published by the Free Software Foundation; either
'version 2 of the License, or (at your option) any later version. This program is
'distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
'the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details. You should have received a copy of the GNU
'General Public License along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Option Explicit

Public WithEvents Main As Form
Attribute Main.VB_VarHelpID = -1
Private WithEvents lstComPorts As ComboBox
Attribute lstComPorts.VB_VarHelpID = -1
Private WithEvents lstMaxSpeed As ComboBox
Attribute lstMaxSpeed.VB_VarHelpID = -1
Private WithEvents lstSkin As ComboBox
Attribute lstSkin.VB_VarHelpID = -1
Private WithEvents cmdOK As CommandButton
Attribute cmdOK.VB_VarHelpID = -1
Private WithEvents cmdCancel As CommandButton
Attribute cmdCancel.VB_VarHelpID = -1
Private WithEvents mnuAbout As Menu
Attribute mnuAbout.VB_VarHelpID = -1

Public Sub Bind(f As Form)
    Set Main = f
    setControls
End Sub

Public Sub Release()
    clearControls
End Sub

Private Sub setControls()
    clearControls
    With Main
        Set lstComPorts = .lstComPorts
        Set lstMaxSpeed = .lstMaxSpeed
        Set lstSkin = .lstSkin
        Set mnuAbout = .mnuAbout
        
        Set cmdOK = .cmdOK
        Set cmdCancel = .cmdCancel
    
    End With
End Sub

Private Sub clearControls()
    With Main
        Set lstComPorts = Nothing
        Set lstMaxSpeed = Nothing
        Set lstSkin = Nothing
        Set mnuAbout = Nothing
        
        Set cmdOK = Nothing
        Set cmdCancel = Nothing
        
    End With
End Sub

Public Sub show(modal, ownerform)
    Main.Top = ownerform.Top
    Main.Left = ownerform.Left
    Load Main
    Main.show modal, ownerform
End Sub

Private Sub cmdOK_Click()

    Dim iPort As Integer
    Dim iSpeed As Integer
    Dim sSkin As String
    iPort = SelectedComPort
    iSpeed = SelectedSpeed
    sSkin = SelectedSkinName
    Release

    gUI.ChangeSettings iPort, iSpeed, sSkin
    Unload Main
End Sub

Private Sub cmdCancel_Click()
    Release
    Unload Main
End Sub

Private Function CurrentSkinIndex() As Integer
    Select Case gUI.skin
    Case "atari810": CurrentSkinIndex = 0
    Case "atari1050": CurrentSkinIndex = 1
    Case "plainjane": CurrentSkinIndex = 2
    Case "bigjane": CurrentSkinIndex = 3
    Case "retrogreen": CurrentSkinIndex = 4
    End Select
End Function

Private Function SelectedSkinName()
    Select Case lstSkin.ListIndex
    Case 0: SelectedSkinName = "atari810"
    Case 1: SelectedSkinName = "atari1050"
    Case 2: SelectedSkinName = "plainjane"
    Case 3: SelectedSkinName = "bigjane"
    Case 4: SelectedSkinName = "retrogreen"
    End Select
End Function

Private Function SelectedComPort()
    SelectedComPort = lstComPorts.ListIndex + 1
End Function

Private Function SelectedSpeed()
    SelectedSpeed = lstMaxSpeed.ListIndex + 1
End Function

Private Sub mnuAbout_Click()
    frmAbout.show vbModal, Main
End Sub

Private Sub main_Load()
    Dim i As Integer
    For i = 1 To 4
        lstComPorts.AddItem "COM" & i
    Next
    For i = 1 To 3
        lstMaxSpeed.AddItem i & "X"
    Next
    lstSkin.AddItem "Atari 810"
    lstSkin.AddItem "Atari 1050"
    lstSkin.AddItem "Plain Jane"
    lstSkin.AddItem "Big Jane"
    lstSkin.AddItem "Retro Green"
    
    lstSkin.ListIndex = CurrentSkinIndex
    If Not gUI.sio Is Nothing Then
        lstComPorts.ListIndex = gUI.sio.serialPort - 1
        lstMaxSpeed.ListIndex = gUI.sio.MaxSpeed - 1
    End If
End Sub

