Attribute VB_Name = "Win32File"
'Copyright (c) 2001 Dan Vernon
'
'This program is free software; you can redistribute it and/or modify it under the terms
'of the GNU General Public License as published by the Free Software Foundation; either
'version 2 of the License, or (at your option) any later version. This program is
'distributed in the hope that it will be useful, but WITHOUT ANY WARRANTY; without even
'the implied warranty of MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
'GNU General Public License for more details. You should have received a copy of the GNU
'General Public License along with this program; if not, write to the Free Software
'Foundation, Inc., 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
Option Explicit

'Win32 API filebox stuff
Public Const MAX_PATH = 260

Public Const BIF_BROWSEFORCOMPUTER = &H1000
Public Const BIF_BROWSEFORPRINTER = &H2000
Public Const BIF_BROWSEINCLUDEFILES = &H4000
Public Const BIF_DONTGOBELOWDOMAIN = &H2
Public Const BIF_RETURNFSANCESTORS = &H8
Public Const BIF_RETURNONLYFSDIRS = &H1
Public Const BIF_STATUSTEXT = &H4
Public Const BIF_USENEWUI = 0

Public Declare Function GetFileAttributes Lib "kernel32" Alias "GetFileAttributesA" (ByVal lpFileName As String) As Long

Type SHFILEINFO
        hIcon As Long                      '  out: icon
        iIcon As Long          '  out: icon index
        dwAttributes As Long               '  out: SFGAO_ flags
        szDisplayName As String * MAX_PATH '  out: display name (or path)
        szTypeName As String * 80         '  out: type name
End Type
Type BROWSEINFO
    hwndOwner As Long
    pidlRoot As Long
    pszDisplayName As String
    lpszTitle As String
    ulFlags As Long
    lpfn As Long
    lParam As Long
    iImage As Integer
End Type

Public Declare Sub Sleep Lib "kernel32" (ByVal dwMilliseconds As Long)

Private Declare Function SHBrowseForFolder Lib "shell32.dll" Alias "SHBrowseForFolderA" (lpbi As BROWSEINFO) As Long
Private Declare Function SHGetPathFromIDList Lib "shell32.dll" (ByVal pidl As Long, ByVal pszPath As String) As Boolean
Private Declare Function GlobalFree Lib "kernel32" (ByVal hMem As Long) As Long
Private Declare Function SHGetFileInfo Lib "shell32.dll" Alias "SHGetFileInfoA" ( _
    ByVal pszPath As String, _
    ByVal dwFileAttributes As Long, _
    psfi As SHFILEINFO, _
    ByVal cbFileInfo As Long, _
    ByVal uFlags As Long) As Long

Public Type OPENFILENAME
        lStructSize As Long
        hwndOwner As Long
        hInstance As Long
        lpstrFilter As String
        lpstrCustomFilter As String
        nMaxCustFilter As Long
        nFilterIndex As Long
        lpstrFile As String
        nMaxFile As Long
        lpstrFileTitle As String
        nMaxFileTitle As Long
        lpstrInitialDir As String
        lpstrTitle As String
        flags As Long
        nFileOffset As Integer
        nFileExtension As Integer
        lpstrDefExt As String
        lCustData As Long
        lpfnHook As Long
        lpTemplateName As String
End Type
Public Const OFN_NOREADONLYRETURN = &H8000
Public Const OFN_OVERWRITEPROMPT = &H2
Public Const OFN_PATHMUSTEXIST = &H800
Public Const OFN_EXPLORER = &H80000
Public Const OFN_HIDEREADONLY = &H4
Public Const OFN_FILEMUSTEXIST = &H1000

Public Declare Function GetOpenFileName Lib "comdlg32.dll" Alias "GetOpenFileNameA" (pOpenfilename As OPENFILENAME) As Long
Public Declare Function GetSaveFileName Lib "comdlg32.dll" Alias "GetSaveFileNameA" (pOpenfilename As OPENFILENAME) As Long

Public Function GetFolder(Caption As String, ParentHwnd As Long) As String
    Dim l As BROWSEINFO
    Dim i As Long
    Dim s As String
    
    With l
        .hwndOwner = ParentHwnd
        .pidlRoot = 0
        .lpfn = 0
        .lpszTitle = Caption
        .ulFlags = BIF_STATUSTEXT 'Or BIF_BROWSEINCLUDEFILES
        .pszDisplayName = String(257, Chr(0))
        .lParam = 0
    End With
    
    i = SHBrowseForFolder(l)
    s = String(MAX_PATH, 0)
    Call SHGetPathFromIDList(i, s)
    s = StripStringTail(s)
    Call GlobalFree(i)
    GetFolder = s
End Function

Public Function OpenFile(Caption As String, Filter As String, ParentHwnd As Long) As String
    Dim ofn As OPENFILENAME
    Dim s As String
    s = String(MAX_PATH, Chr(0))
    Dim hf As Long

    With ofn
        .lStructSize = LenB(ofn)
        .hwndOwner = ParentHwnd
        .lpstrFile = s
        .nMaxFile = Len(s)
        .lpstrFilter = Filter
        .nFilterIndex = 2
        .lpstrTitle = Caption
        .lpstrInitialDir = 0
        .flags = OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST
    End With
    
    If GetOpenFileName(ofn) Then
        OpenFile = StripStringTail(ofn.lpstrFile)
    End If
End Function

Public Function SaveFile(Caption As String, Filter As String, ParentHwnd As Long) As String
    Dim ofn As OPENFILENAME
    Dim s As String
    s = String(MAX_PATH, Chr(0))
    Dim hf As Long

    With ofn
        .lStructSize = LenB(ofn)
        .hwndOwner = ParentHwnd
        .lpstrFile = s
        .nMaxFile = Len(s)
        .lpstrFilter = Filter
        .lpstrDefExt = "atr"
        .nFilterIndex = 2
        .lpstrTitle = Caption
        .lpstrInitialDir = 0
        .flags = OFN_PATHMUSTEXIST Or OFN_FILEMUSTEXIST
    End With
    
    If GetSaveFileName(ofn) Then
        SaveFile = StripStringTail(ofn.lpstrFile)
    End If
End Function

Public Function StripStringTail(psStr As Variant) As String
    On Error Resume Next
    Dim i As Integer
    
    If Trim(psStr & "") = "" Then Exit Function
    For i = 1 To Len(psStr)
        If Mid(psStr, i, 1) = Chr(0) Then
            Exit Function
        Else
            StripStringTail = StripStringTail & Mid(psStr, i, 1)
        End If
    Next
End Function


